diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/wifi-phy-operating-channel.cc ns-3.43/src/wifi/model/wifi-phy-operating-channel.cc
--- ns-3.42/src/wifi/model/wifi-phy-operating-channel.cc	2024-05-29 15:29:47.212073800 -0700
+++ ns-3.43/src/wifi/model/wifi-phy-operating-channel.cc	2024-10-09 16:41:10.132656800 -0700
@@ -288,54 +301,129 @@
 bool
 WifiPhyOperatingChannel::IsSet() const
 {
-    return m_channelIt != m_frequencyChannels.end();
+    return !m_channelIts.empty();
 }
 
 void
-WifiPhyOperatingChannel::Set(uint8_t number,
-                             uint16_t frequency,
-                             uint16_t width,
-                             WifiStandard standard,
-                             WifiPhyBand band)
+WifiPhyOperatingChannel::Set(const std::vector<FrequencyChannelInfo>& segments,
+                             WifiStandard standard)
 {
-    NS_LOG_FUNCTION(this << +number << frequency << width << standard << band);
+    std::stringstream ss;
+    for (const auto& segment : segments)
+    {
+        ss << segment;
+    }
+    NS_LOG_FUNCTION(this << ss.str() << standard);
+
+    NS_ASSERT_MSG(!segments.empty(), "At least one frequency segment has to be provided");
+
+    ConstIteratorSet channelIts{};
+    for (const auto& segment : segments)
+    {
+        if (const auto channelIt =
+                FindFirst(segment.number, segment.frequency, segment.width, standard, segment.band);
+            channelIt != m_frequencyChannels.cend() &&
+            FindFirst(segment.number,
+                      segment.frequency,
+                      segment.width,
+                      standard,
+                      segment.band,
+                      std::next(channelIt)) == m_frequencyChannels.cend())
+        {
+            // a unique channel matches the specified criteria
+            channelIts.insert(channelIt);
+        }
+    }
 
-    auto channelIt = FindFirst(number, frequency, width, standard, band);
+    if (channelIts.size() != segments.size())
+    {
+        // if a unique channel was not found, throw an exception (mainly for unit testing this code)
+        throw std::runtime_error(
+            "WifiPhyOperatingChannel: No unique channel found given the specified criteria");
+    }
+
+    auto it = channelIts.begin();
+    for (std::size_t segment = 0; segment < (channelIts.size() - 1); ++segment)
+    {
+        const auto freq = (*it)->frequency;
+        const auto width = (*it)->width;
+        const auto band = (*it)->band;
+        const auto maxFreq = freq + (width / 2);
+        ++it;
+        const auto nextFreq = (*it)->frequency;
+        const auto nextWidth = (*it)->width;
+        const auto nextBand = (*it)->band;
+        const auto nextMinFreq = nextFreq - (nextWidth / 2);
+        if (maxFreq >= nextMinFreq)
+        {
+            throw std::runtime_error(
+                "WifiPhyOperatingChannel is invalid: segments cannot be adjacent nor overlap");
+        }
+        if (band != nextBand)
+        {
+            throw std::runtime_error("WifiPhyOperatingChannel is invalid: all segments shall "
+                                     "belong to the same band");
+        }
+    }
 
-    if (channelIt != m_frequencyChannels.end() &&
-        FindFirst(number, frequency, width, standard, band, std::next(channelIt)) ==
-            m_frequencyChannels.end())
+    if ((channelIts.size() > 2) ||
+        ((channelIts.size() == 2) &&
+         !std::all_of(channelIts.cbegin(), channelIts.cend(), [](const auto& channel) {
+             return channel->width == 80;
+         })))
     {
-        // a unique channel matches the specified criteria
-        m_channelIt = channelIt;
-        m_primary20Index = 0;
-        return;
+        throw std::runtime_error("WifiPhyOperatingChannel is invalid: only 80+80MHz is "
+                                 "expected as non-contiguous channel");
     }
 
-    // if a unique channel was not found, throw an exception (mainly for unit testing this code)
-    throw std::runtime_error(
-        "WifiPhyOperatingChannel: No unique channel found given the specified criteria");
+    m_channelIts = channelIts;
+    m_primary20Index = 0;
 }
 
 void
-WifiPhyOperatingChannel::SetDefault(uint16_t width, WifiStandard standard, WifiPhyBand band)
+WifiPhyOperatingChannel::SetDefault(MHz_u width, WifiStandard standard, WifiPhyBand band)
 {
     NS_LOG_FUNCTION(this << width << standard << band);
-
-    Set(GetDefaultChannelNumber(width, standard, band), 0, width, standard, band);
+    Set({{GetDefaultChannelNumber(width, standard, band), 0, width, band}}, standard);
 }
 
 uint8_t
-WifiPhyOperatingChannel::GetDefaultChannelNumber(uint16_t width,
-                                                 WifiStandard standard,
-                                                 WifiPhyBand band)
-{
-    auto channelIt = FindFirst(0, 0, width, standard, band);
-
+WifiPhyOperatingChannel::GetDefaultChannelNumber(
+    MHz_u width,
+    WifiStandard standard,
+    WifiPhyBand band,
+    std::optional<uint8_t> previousChannelNumber /* = std::nullopt */)
+{
+    auto start = m_frequencyChannels.begin();
+    auto prevSegmentChannelIt = m_frequencyChannels.end();
+    if (previousChannelNumber)
+    {
+        prevSegmentChannelIt = FindFirst(*previousChannelNumber, 0, width, standard, band, start);
+        if (prevSegmentChannelIt != m_frequencyChannels.end())
+        {
+            start = std::next(prevSegmentChannelIt);
+        }
+    }
+    auto channelIt = FindFirst(0, 0, width, standard, band, start);
+    if (prevSegmentChannelIt != m_frequencyChannels.end() && channelIt != m_frequencyChannels.end())
+    {
+        const auto prevFreq = prevSegmentChannelIt->frequency;
+        const auto prevWidth = prevSegmentChannelIt->width;
+        const auto prevMaxFreq = prevFreq + (prevWidth / 2);
+        const auto nextFreq = channelIt->frequency;
+        const auto nextWidth = channelIt->width;
+        const auto nextMinFreq = nextFreq - (nextWidth / 2);
+        if (prevMaxFreq <= nextMinFreq)
+        {
+            // segments are contiguous to each others, find next segment to make sure they are
+            // not contiguous
+            channelIt = FindFirst(0, 0, width, standard, band, std::next(channelIt));
+        }
+    }
     if (channelIt != m_frequencyChannels.end())
     {
         // a channel matches the specified criteria
-        return std::get<0>(*channelIt);
+        return channelIt->number;
     }
 
     // if a default channel was not found, throw an exception (mainly for unit testing this code)
@@ -345,32 +433,32 @@
 
 WifiPhyOperatingChannel::ConstIterator
 WifiPhyOperatingChannel::FindFirst(uint8_t number,
-                                   uint16_t frequency,
-                                   uint16_t width,
+                                   MHz_u frequency,
+                                   MHz_u width,
                                    WifiStandard standard,
                                    WifiPhyBand band,
                                    ConstIterator start)
 {
     // lambda used to match channels against the specified criteria
     auto predicate = [&](const FrequencyChannelInfo& channel) {
-        if (number != 0 && std::get<0>(channel) != number)
+        if (number != 0 && channel.number != number)
         {
             return false;
         }
-        if (frequency != 0 && std::get<1>(channel) != frequency)
+        if (frequency != 0 && channel.frequency != frequency)
         {
             return false;
         }
-        if (width != 0 && std::get<2>(channel) != width)
+        if (width != 0 && channel.width != width)
         {
             return false;
         }
         if (standard != WIFI_STANDARD_UNSPECIFIED &&
-            std::get<3>(channel) != GetFrequencyChannelType(standard))
+            channel.type != GetFrequencyChannelType(standard))
         {
             return false;
         }
-        if (std::get<4>(channel) != band)
+        if (band != WIFI_PHY_BAND_UNSPECIFIED && channel.band != band)
         {
             return false;
         }
@@ -393,70 +481,145 @@
 }
 
 uint8_t
-WifiPhyOperatingChannel::GetNumber() const
+WifiPhyOperatingChannel::GetNumber(std::size_t segment /* = 0 */) const
 {
     NS_ASSERT(IsSet());
-    return std::get<0>(*m_channelIt);
+    return (*std::next(m_channelIts.begin(), segment))->number;
 }
 
-uint16_t
-WifiPhyOperatingChannel::GetFrequency() const
+MHz_u
+WifiPhyOperatingChannel::GetFrequency(std::size_t segment /* = 0 */) const
 {
     NS_ASSERT(IsSet());
-    return std::get<1>(*m_channelIt);
+    return (*std::next(m_channelIts.begin(), segment))->frequency;
 }
 
-uint16_t
-WifiPhyOperatingChannel::GetWidth() const
+MHz_u
+WifiPhyOperatingChannel::GetWidth(std::size_t /* segment = 0 */) const
 {
     NS_ASSERT(IsSet());
-    return std::get<2>(*m_channelIt);
+    // Current specs only allow all segments to be the same width
+    return (*m_channelIts.cbegin())->width;
 }
 
 WifiPhyBand
 WifiPhyOperatingChannel::GetPhyBand() const
 {
     NS_ASSERT(IsSet());
-    return std::get<4>(*m_channelIt);
+    // Current specs only allow all segments to be the same band
+    return (*m_channelIts.cbegin())->band;
 }
 
 bool
 WifiPhyOperatingChannel::IsOfdm() const
 {
     NS_ASSERT(IsSet());
-    return std::get<FrequencyChannelType>(*m_channelIt) == WIFI_PHY_OFDM_CHANNEL;
+    return ((*m_channelIts.cbegin())->type == FrequencyChannelType::OFDM);
 }
 
 bool
 WifiPhyOperatingChannel::IsDsss() const
 {
     NS_ASSERT(IsSet());
-    return std::get<FrequencyChannelType>(*m_channelIt) == WIFI_PHY_DSSS_CHANNEL;
+    return ((*m_channelIts.cbegin())->type == FrequencyChannelType::DSSS);
 }
 
 bool
 WifiPhyOperatingChannel::Is80211p() const
 {
     NS_ASSERT(IsSet());
-    return std::get<FrequencyChannelType>(*m_channelIt) == WIFI_PHY_80211p_CHANNEL;
+    return ((*m_channelIts.cbegin())->type == FrequencyChannelType::CH_80211P);
 }
 
-uint8_t
-WifiPhyOperatingChannel::GetPrimaryChannelIndex(uint16_t primaryChannelWidth) const
+std::vector<uint8_t>
+WifiPhyOperatingChannel::GetNumbers() const
+{
+    NS_ASSERT(IsSet());
+    std::vector<uint8_t> channelNumbers{};
+    std::transform(m_channelIts.cbegin(),
+                   m_channelIts.cend(),
+                   std::back_inserter(channelNumbers),
+                   [](const auto& channel) { return channel->number; });
+    return channelNumbers;
+}
+
+std::vector<MHz_u>
+WifiPhyOperatingChannel::GetFrequencies() const
 {
-    NS_LOG_FUNCTION(this << primaryChannelWidth);
+    NS_ASSERT(IsSet());
+    std::vector<MHz_u> centerFrequencies{};
+    std::transform(m_channelIts.cbegin(),
+                   m_channelIts.cend(),
+                   std::back_inserter(centerFrequencies),
+                   [](const auto& channel) { return channel->frequency; });
+    return centerFrequencies;
+}
+
+std::vector<MHz_u>
+WifiPhyOperatingChannel::GetWidths() const
+{
+    NS_ASSERT(IsSet());
+    std::vector<MHz_u> channelWidths{};
+    std::transform(m_channelIts.cbegin(),
+                   m_channelIts.cend(),
+                   std::back_inserter(channelWidths),
+                   [](const auto& channel) { return channel->width; });
+    return channelWidths;
+}
 
-    if (primaryChannelWidth % 20 != 0)
+MHz_u
+WifiPhyOperatingChannel::GetTotalWidth() const
+{
+    NS_ASSERT(IsSet());
+    return std::accumulate(m_channelIts.cbegin(),
+                           m_channelIts.cend(),
+                           0,
+                           [](MHz_u sum, const auto& channel) { return sum + channel->width; });
+}
+
+WifiChannelWidthType
+WifiPhyOperatingChannel::GetWidthType() const
+{
+    NS_ASSERT(IsSet());
+    switch (static_cast<uint16_t>(GetTotalWidth()))
+    {
+    case 20:
+        return WifiChannelWidthType::CW_20MHZ;
+    case 22:
+        return WifiChannelWidthType::CW_22MHZ;
+    case 5:
+        return WifiChannelWidthType::CW_5MHZ;
+    case 10:
+        return WifiChannelWidthType::CW_10MHZ;
+    case 40:
+        return WifiChannelWidthType::CW_40MHZ;
+    case 80:
+        return WifiChannelWidthType::CW_80MHZ;
+    case 160:
+        return (m_channelIts.size() == 2) ? WifiChannelWidthType::CW_80_PLUS_80MHZ
+                                          : WifiChannelWidthType::CW_160MHZ;
+    case 2160:
+        return WifiChannelWidthType::CW_2160MHZ;
+    case 0:
+    default:
+        return WifiChannelWidthType::UNKNOWN;
+    }
+}
+
+uint8_t
+WifiPhyOperatingChannel::GetPrimaryChannelIndex(MHz_u primaryChannelWidth) const
+{
+    if (static_cast<uint16_t>(primaryChannelWidth) % 20 != 0)
     {
         NS_LOG_DEBUG("The operating channel width is not a multiple of 20 MHz; return 0");
         return 0;
     }
 
-    NS_ASSERT(primaryChannelWidth <= GetWidth());
+    NS_ASSERT(primaryChannelWidth <= GetTotalWidth());
 
     // the index of primary40 is half the index of primary20; the index of
     // primary80 is half the index of primary40, ...
-    uint16_t width = 20;
+    MHz_u width = 20;
     uint8_t index = m_primary20Index;
 
     while (width < primaryChannelWidth)
@@ -464,18 +627,15 @@
         index /= 2;
         width *= 2;
     }
-    NS_LOG_LOGIC("Return primary index " << +index);
     return index;
 }
 
 uint8_t
-WifiPhyOperatingChannel::GetSecondaryChannelIndex(uint16_t secondaryChannelWidth) const
+WifiPhyOperatingChannel::GetSecondaryChannelIndex(MHz_u secondaryChannelWidth) const
 {
-    NS_LOG_FUNCTION(this << secondaryChannelWidth);
     const uint8_t primaryIndex = GetPrimaryChannelIndex(secondaryChannelWidth);
     const uint8_t secondaryIndex =
         (primaryIndex % 2 == 0) ? (primaryIndex + 1) : (primaryIndex - 1);
-    NS_LOG_LOGIC("Return secondary index " << +secondaryIndex);
     return secondaryIndex;
 }
 
@@ -484,65 +644,129 @@
 {
     NS_LOG_FUNCTION(this << +index);
 
-    NS_ABORT_MSG_IF(index > 0 && index >= GetWidth() / 20, "Primary20 index out of range");
+    NS_ABORT_MSG_IF(index > 0 && index >= GetTotalWidth() / 20, "Primary20 index out of range");
     m_primary20Index = index;
 }
 
-uint16_t
-WifiPhyOperatingChannel::GetPrimaryChannelCenterFrequency(uint16_t primaryChannelWidth) const
+uint8_t
+WifiPhyOperatingChannel::GetPrimarySegmentIndex(MHz_u primaryChannelWidth) const
 {
-    uint16_t freq = GetFrequency() - GetWidth() / 2. +
-                    (GetPrimaryChannelIndex(primaryChannelWidth) + 0.5) * primaryChannelWidth;
-
-    NS_LOG_FUNCTION(this << primaryChannelWidth << freq);
-    return freq;
+    if (m_channelIts.size() < 2)
+    {
+        return 0;
+    }
+    // Note: this function assumes no more than 2 segments are used
+    const auto numIndices = GetTotalWidth() / primaryChannelWidth;
+    const auto primaryIndex = GetPrimaryChannelIndex(primaryChannelWidth);
+    return (primaryIndex >= (numIndices / 2)) ? 1 : 0;
 }
 
-uint16_t
-WifiPhyOperatingChannel::GetSecondaryChannelCenterFrequency(uint16_t secondaryChannelWidth) const
+uint8_t
+WifiPhyOperatingChannel::GetSecondarySegmentIndex(MHz_u primaryChannelWidth) const
 {
-    const uint8_t primaryIndex = GetPrimaryChannelIndex(secondaryChannelWidth);
-    const uint16_t primaryCenterFrequency = GetPrimaryChannelCenterFrequency(secondaryChannelWidth);
-    return (primaryIndex % 2 == 0) ? (primaryCenterFrequency + secondaryChannelWidth)
-                                   : (primaryCenterFrequency - secondaryChannelWidth);
+    NS_ABORT_MSG_IF(primaryChannelWidth > GetWidth(),
+                    "Primary channel width cannot be larger than the width of a frequency segment");
+    if (m_channelIts.size() < 2)
+    {
+        return 0;
+    }
+    // Note: this function assumes no more than 2 segments are used
+    const auto numIndices = GetTotalWidth() / primaryChannelWidth;
+    const auto secondaryIndex = GetSecondaryChannelIndex(primaryChannelWidth);
+    return (secondaryIndex >= (numIndices / 2)) ? 1 : 0;
+}
+
+MHz_u
+WifiPhyOperatingChannel::GetPrimaryChannelCenterFrequency(MHz_u primaryChannelWidth) const
+{
+    const auto segmentIndex = GetPrimarySegmentIndex(primaryChannelWidth);
+    // we assume here that all segments have the same width
+    const auto segmentWidth = GetWidth(segmentIndex);
+    // segmentOffset has to be an (unsigned) integer to ensure correct calculation
+    const uint8_t segmentOffset = (segmentIndex * (segmentWidth / primaryChannelWidth));
+    return GetFrequency(segmentIndex) - segmentWidth / 2. +
+           (GetPrimaryChannelIndex(primaryChannelWidth) - segmentOffset + 0.5) *
+               primaryChannelWidth;
+}
+
+MHz_u
+WifiPhyOperatingChannel::GetSecondaryChannelCenterFrequency(MHz_u secondaryChannelWidth) const
+{
+    const auto segmentIndex = GetSecondarySegmentIndex(secondaryChannelWidth);
+    // we assume here that all segments have the same width
+    const auto segmentWidth = GetWidth(segmentIndex);
+    // segmentOffset has to be an (unsigned) integer to ensure correct calculation
+    const uint8_t segmentOffset = (segmentIndex * (segmentWidth / secondaryChannelWidth));
+    return GetFrequency(segmentIndex) - segmentWidth / 2. +
+           (GetSecondaryChannelIndex(secondaryChannelWidth) - segmentOffset + 0.5) *
+               secondaryChannelWidth;
 }
 
 uint8_t
-WifiPhyOperatingChannel::GetPrimaryChannelNumber(uint16_t primaryChannelWidth,
+WifiPhyOperatingChannel::GetPrimaryChannelNumber(MHz_u primaryChannelWidth,
                                                  WifiStandard standard) const
 {
+    NS_ABORT_MSG_IF(primaryChannelWidth > GetWidth(),
+                    "Primary channel width cannot be larger than the width of a frequency segment");
     auto frequency = GetPrimaryChannelCenterFrequency(primaryChannelWidth);
     NS_ASSERT_MSG(IsSet(), "No channel set");
-    auto& [chanNumber, centerFreq, channelWidth, channelType, band] = *m_channelIt;
-    auto primaryChanIt = FindFirst(0, frequency, primaryChannelWidth, standard, band);
+    auto primaryChanIt = FindFirst(0, frequency, primaryChannelWidth, standard, GetPhyBand());
     NS_ASSERT_MSG(primaryChanIt != m_frequencyChannels.end(), "Primary channel number not found");
-    return std::get<0>(*primaryChanIt);
+    return primaryChanIt->number;
+}
+
+WifiPhyOperatingChannel
+WifiPhyOperatingChannel::GetPrimaryChannel(MHz_u primaryChannelWidth) const
+{
+    NS_ASSERT_MSG(IsSet(), "No channel set");
+    NS_ASSERT_MSG(primaryChannelWidth <= GetTotalWidth(),
+                  "Requested primary channel width ("
+                      << primaryChannelWidth << " MHz) exceeds total width (" << GetTotalWidth()
+                      << " MHz)");
+
+    if (primaryChannelWidth == GetTotalWidth())
+    {
+        return *this;
+    }
+
+    const auto frequency = GetPrimaryChannelCenterFrequency(primaryChannelWidth);
+    auto primaryChanIt =
+        FindFirst(0, frequency, primaryChannelWidth, WIFI_STANDARD_UNSPECIFIED, GetPhyBand());
+    NS_ABORT_MSG_IF(primaryChanIt == m_frequencyChannels.end(), "Primary channel number not found");
+
+    WifiPhyOperatingChannel primaryChannel(primaryChanIt);
+
+    const auto primaryIndex = m_primary20Index - (GetPrimaryChannelIndex(primaryChannelWidth) *
+                                                  (primaryChannelWidth / 20));
+    primaryChannel.SetPrimary20Index(primaryIndex);
+
+    return primaryChannel;
 }
 
 std::set<uint8_t>
-WifiPhyOperatingChannel::GetAll20MHzChannelIndicesInPrimary(uint16_t width) const
+WifiPhyOperatingChannel::GetAll20MHzChannelIndicesInPrimary(MHz_u width) const
 {
-    if (width > GetWidth())
+    if (width > GetTotalWidth())
     {
         // a primary channel of the given width does not exist
         return {};
     }
 
-    uint16_t currWidth = 20; // MHz
+    MHz_u currWidth = 20;
     std::set<uint8_t> indices;
     indices.insert(m_primary20Index);
 
     while (currWidth < width)
     {
         indices.merge(GetAll20MHzChannelIndicesInSecondary(indices));
-        currWidth <<= 1;
+        currWidth *= 2;
     }
 
     return indices;
 }
 
 std::set<uint8_t>
-WifiPhyOperatingChannel::GetAll20MHzChannelIndicesInSecondary(uint16_t width) const
+WifiPhyOperatingChannel::GetAll20MHzChannelIndicesInSecondary(MHz_u width) const
 {
     return GetAll20MHzChannelIndicesInSecondary(GetAll20MHzChannelIndicesInPrimary(width));
 }
@@ -551,21 +775,21 @@
 WifiPhyOperatingChannel::GetAll20MHzChannelIndicesInSecondary(
     const std::set<uint8_t>& primaryIndices) const
 {
-    if (primaryIndices.empty() || GetWidth() == 20)
+    if (primaryIndices.empty() || GetTotalWidth() == 20)
     {
         return {};
     }
 
     uint8_t size = 1;
-    uint16_t primaryWidth = 20; // MHz
+    MHz_u primaryWidth = 20;
 
     // find the width of the primary channel corresponding to the size of the given set
     while (size != primaryIndices.size())
     {
         size <<= 1;
-        primaryWidth <<= 1;
+        primaryWidth *= 2;
 
-        if (primaryWidth >= GetWidth())
+        if (primaryWidth >= GetTotalWidth())
         {
             // the width of the primary channel resulting from the given indices
             // exceeds the width of the operating channel
@@ -583,15 +807,15 @@
 }
 
 std::set<uint8_t>
-WifiPhyOperatingChannel::Get20MHzIndicesCoveringRu(HeRu::RuSpec ru, uint16_t width) const
+WifiPhyOperatingChannel::Get20MHzIndicesCoveringRu(HeRu::RuSpec ru, MHz_u width) const
 {
     auto ruType = ru.GetRuType();
 
     NS_ASSERT_MSG(HeRu::GetBandwidth(ruType) <= width,
                   "No RU of type " << ruType << " is contained in a " << width << " MHz channel");
-    NS_ASSERT_MSG(width <= GetWidth(),
+    NS_ASSERT_MSG(width <= GetTotalWidth(),
                   "The given width (" << width << " MHz) exceeds the operational width ("
-                                      << GetWidth() << " MHz)");
+                                      << GetTotalWidth() << ")");
 
     // trivial case: 2x996-tone RU
     if (ruType == HeRu::RU_2x996_TONE)
@@ -695,10 +919,16 @@
     return indices;
 }
 
+std::size_t
+WifiPhyOperatingChannel::GetNSegments() const
+{
+    return m_channelIts.size();
+}
+
 bool
 WifiPhyOperatingChannel::operator==(const WifiPhyOperatingChannel& other) const
 {
-    return m_channelIt == other.m_channelIt;
+    return m_channelIts == other.m_channelIts;
 }
 
 bool
@@ -712,8 +942,24 @@
 {
     if (channel.IsSet())
     {
-        os << "channel " << +channel.GetNumber() << " in band " << channel.GetPhyBand()
-           << " frequency " << channel.GetFrequency() << " width " << channel.GetWidth();
+        const auto numSegments = channel.GetNSegments();
+        for (std::size_t segmentId = 0; segmentId < numSegments; ++segmentId)
+        {
+            if (numSegments > 1)
+            {
+                os << "segment " << segmentId << " ";
+            }
+            os << "channel " << +channel.GetNumber() << " frequency " << channel.GetFrequency()
+               << " width " << channel.GetWidth() << " band " << channel.GetPhyBand();
+            if ((segmentId == 0) && (static_cast<uint16_t>(channel.GetTotalWidth()) % 20 == 0))
+            {
+                os << " primary20 " << +channel.GetPrimaryChannelIndex(20);
+            }
+            if (segmentId < numSegments - 1)
+            {
+                os << " ";
+            }
+        }
     }
     else
     {
